***********************************************
*                                             *
* BIBLIO - Das Bibliotheksprogramm Ver. 1.0   *
* Dbase IV Programm                           *
* von KELICH Andreas                          *
* Roemerstr. 6                                *
* A-6060 Ampass, Austria                      *
*                                             *
***********************************************

clear
*
* Bibliographiedatenbank da?
*

if file("litera.dbf")=.f.
  ? "Keine Bibliographiedatenbank!"
  ?
  read
  quit
endif

*
* Index vorhanden?
*

if file("litera.ndx")=.f.
  ? "Keine Indexdatei fuer die Bibliographie"
  ? 
  ? "Indexdatei wird erstellt. Bitte Geduld..."
  use litera
  index on left(autoren,30)+jahr to litera.ndx
  close all
  ? "Index angelegt."
  ?
  ? "<Taste>"
  read
endif

*
* Oeffnen der Datenbanken im Bereich 1 ...
*
set console off
use litera in 1 index litera
set console on
?" Biblographiedatenbank geoeffnet."

*
* Suchdatenbank da???
*

if file("suche.dbf")=.f.
  ? "Keine Suchdatenbank"
  select 1
  ? "Suchdatenbank wird angelegt ..."
  copy struc to suche.dbf
  ? "Suchdatenbank angelegt."
  ?
  ? "<Taste>"
  read
endif

* Suchdatenbank wird in Bereich 2 geoeffnet
set console off
use suche  in 2
set console on
? "Suchdatenbank geoeffnet."
select 1


*
*
* Programm Hauptschleife !!!
*
*

do while .t.
  
  clear
  ? 
  ?
  ? " BBBB  II BBBB  LL    II  OOOO"
  ? " B   B II B   B LL    II O    O"
  ? " B   B II B   B LL    II O    O"
  ? " BBBB  II BBBB  LL    II O    O"
  ? " B   B II B   B LL    II O    O"
  ? " B   B II B   B LLLLL II O    O"
  ? " BBBB  II BBBB  LLLLL II  OOOO"
  ?
  ? " Das Bibliographieverwaltungsprogramm"
  ? " -----------------------------------------"
  ? " von KELICH Andreas"
  ? "     Roemerstr. 6"
  ? "     A-6060 Ampass, Austria"
  ?
  ? " -----------------------------------------"
  ? " <N>   Neue Werke erfassen "
  ? " <CR>  Werke bearbeiten"
  ? " <S>   Suchen"
  ? " <E>   Exportieren"
  ? " <I>   Importieren"
  ? " <D>   Datenbankinformation"
  ? " <P>   Pfade und Wartung"
  ?
  ? " <ESC> Beenden"
  ? " -----------------------------------------"
   
  read


  do case

    case lastkey()=27
      close all
      exit

    case lastkey()=83   && SUCHEN
    case lastkey()=115
      do while .t.
	clear

	@ 0,0 say "BIBLIO: Suchfunktionen"
	@ 3,0 say "<CR>  In Feldern"
	@ 4,0 say "<T>   Volltextsuche im gesamten Datensatz"
	@ 6,0 say "<S>   Suchdatenbank Loeschen!"
	@ 7,0 say "<D>   Suchdatenbank Darstellen"
	@ 8,0 say "<I>   Informationen ueber die Suchdatenbank"
	@10,0 say "<A>   Auswahl einschraenken, nach dem Quellentyp"
	@13,0 say "<ESC> Zurueck"
	read
	do case
	  case lastkey()=13 && Felder aus datenbank durchsuchen

	  case lastkey()=68 && Database Suche darstellen
	  case lastkey()=100
	    clear
	    set console off
	    select 2 && Suchdatenbank selektieren
	    go top
	    set console on
	    if recno()<>0
	      browse fields autoren /R,titel /R,journal /R,ausgabe /R, band /R, seiten/R, jahr /R
	    else
	      ? "Es sind keine Suchergebnisse in der Suchdatenbank vorhanden."
	      ?
	      ? "<Taste druecken>"
	      read
	    endif
	    select 1 && Zurueck zur Datenbank der Werke

	  case lastkey()=73 && Informationen ueber die Suchdatenbank
	  case lastkey()=105
	    clear
	    @ 0,0 say "BIBLIO: Suchfunktionen: Infos ueber die Suchdatenbank"
	    set console off
	    mono=0
	    dipl=0
	    diss=0
	    habi=0
	    sati=0
	    jour=0
	    samm=0

	    select 2 && suchdatenbank auswaehlen
	    set console on
	    ?
	    ? "Suchergebniss : ",reccount(), " Werke"
	    ?

	    set console off        
	    
	    go top
	    do while eof()=.f.
	      do case
		case quellentyp=1
		  diss=diss+1
		case quellentyp=2
		  habi=habi+1
		case quellentyp=3
		  mono=mono+1
		case quellentyp=4
		  jour=jour+1
		case quellentyp=5
		  sati=sati+1
		case quellentyp=6
		  samm=samm+1
		case quellentyp=7
		  dipl=dipl+1
	      endcase
	      skip 1
	    enddo

	    set console on

	    ? "Monographien   : ",ltrim(str(mono))
	    ? "Diplomarbeiten : ",ltrim(str(dipl))
	    ? "Dissertationen : ",ltrim(str(diss))
	    ? "Habilitationen : ",ltrim(str(habi))
	    ? "Journalartikel : ",ltrim(str(jour))
	    ? "Sammelwerke    : ",ltrim(str(samm))
	    ? "Sammelwerktitel: ",ltrim(str(sati))

	    select 1 && Auswahl der Datenbank Werke
	    ?
	    ? "<Taste druecken>"
	    read

	  case lastkey()=65 && Auswahl einschraenken, nach Quellentyp
	  case lastkey()=97
	    do while .t.
	      
	      clear

	      @ 7,0 say "Filter      :"
	      @ 8,0 say " <CR>  Alle Datensaetze anzeigen"
	      @ 9,0 say " <M>   Monographien"
	      @10,0 say " <D>   Dissertationen"
	      @11,0 say " <A>   Diplomarbeiten"
	      @12,0 say " <J>   Journalartikel"
	      @13,0 say " <S>   Sammelwerke"
	      @14,0 say " <T>   Sammelwerktitel"
	      @15,0 say " <H>   Habilitationen"
	      read

	      do case
		case lastkey()=13
		  set filter to
		  @ 7,15 say "Alle Datensaetze"
		  exit
		case lastkey()=65     
		case lastkey()=97
		  set filter to quellentyp=7
		  @ 7,15 say "Nur Diplomarbeiten"
		  exit
		case lastkey()=68
		case lastkey()=100
		  set filter to quellentyp=1
		  @ 7,15 say "Nur Dissertationen"
		  exit
		case lastkey()=74
		case lastkey()=106
		  set filter to quellentyp=4
		  @ 7,15 say "Nur Journalartikel"
		  exit
		case lastkey()=77
		case lastkey()=109
		  set filter to quellentyp=3
		  @ 7,15 say "Nur Monographien"
		  exit
		case lastkey()=83
		case lastkey()=115
		  set filter to quellentyp=6
		  @ 7,15 say "Nur Sammelwerke"
		  exit
		case lastkey()=72
		case lastkey()=104
		  set filter to quellentyp=2
		  @ 7,15 say "Nur Habilitationen"
		  exit
		case lastkey()=84
		case lastkey()=116
		  set filter to quellentyp=5
		  @ 7,15 say "Nur Sammelwerktitel"
		  exit
	      endcase
	      
	    enddo
	    
	  case lastkey()=84 && Volltextsuche
	  case lastkey()=116
	    do while .t.
	      clear
	      store space(55) to suchen
	      @ 0,0 say "BIBLIO: Suchfunktionen: Volltextsuche"
	      
	      @ 2,0 say "Der Einsatz von Wildcards (?,*) ist moeglich."
	      @ 3,0 say "?  Ersetzt ein Zeichen"
	      @ 4,0 say "*  Ersetzt mehrere Zeichen"

	      @ 6,0 say "Fuehrende und abschliessende Wildcards koennen weggelassen werden,"
	      @ 7,0 say "denn es wird immer ein Ausdruck der Form *Suchbegriff* gebildet."
	      
	      @ 9,0 say "Es wird nicht zwischen Gross- und Kleinschreibung unterschieden!"
	      
	      @11,0 say "Suchbegriff: " get suchen
	      read
	      @13,0 say "<CR>  Suche starten"
	      @14,0 say "<ESC> Abbrechen"
	      
	      set console off
	      store 0 to taste
	      taste=inkey(0)
	      set console on
	      
	      do case
		case lastkey()=13 && Volltextsuche ausfuehren
		  if len(ltrim(rtrim(suchen)))=0
		    ? "Es wurde kein Suchbegriff angegeben!!!"
		    ? 
		    ? "<Taste druecken>" 
		    read
		  else
		    set console off
		    select 1
		    go top                         
		    zaehler=0
		    zaehler2=0
		    suchen=upper("*"+ltrim(rtrim(suchen))+"*")
		    set console on

		    define window textsuche from 13,3 to 24,65
		    activate window textsuche
		    clear
		    @0,1 say "Suchabfrage laeuft ..."

		    do while eof()=.f.
		      if like(suchen,ltrim(rtrim(upper(autoren))))=.t.
			do werksuch                      
		      else
			if like(suchen,ltrim(rtrim(upper(titel))))=.t.
			  do werksuch                        
			else
			  if like(suchen,ltrim(rtrim(upper(band))))=.t.
			    do werksuch  
			  else
			    if like(suchen,ltrim(rtrim(upper(ausgabe))))=.t.
			      do werksuch
			    else
			      if like(suchen,ltrim(rtrim(upper(jahr))))=.t.
				do werksuch
			      else
				if like(suchen,ltrim(rtrim(upper(verlag))))=.t.
				  do werksuch
				else
				  if like(suchen,ltrim(rtrim(upper(sonstiges))))=.t.
				    do werksuch
				  else
				    if like(suchen,ltrim(rtrim(upper(stichworte))))=.t.
				      do werksuch
				    else
				      if like(suchen,ltrim(rtrim(upper(auflage))))=.t.
					do werksuch
				      else
					if like(suchen,ltrim(rtrim(upper(seiten))))=.t.
					  do werksuch
					else
					  if like(suchen,ltrim(rtrim(upper(journal))))=.t.
					    do werksuch
					  else
					    if like(suchen,ltrim(rtrim(upper(sprache))))=.t.
					      do werksuch
					    else
					      if like(suchen,ltrim(rtrim(upper(ort))))=.t.
						do werksuch
					      endif
					    endif
					  endif
					endif
				      endif
				    endif
				  endif
				endif
			      endif
			    endif
			  endif
			endif
		      endif
		      set console off
		      skip 1
		      zaehler2=zaehler2+1
		      set console on
		      @ 2,1 say "Es wurden bereits "+ltrim(str(zaehler2))+" Werke von "+ltrim(str(reccount()))+" gespeichterten" 
		      @ 3,1 say "durchsucht. Das sind "+ltrim(str(zaehler2/(reccount()/100)))+"%."

		    enddo
		    set console on
		  endif
		  * 
		  * Suche abgeschlossen
		  *
		  @ 0,12 say "                   "
		  @ 7,1 say "Die Suche ist abgeschlossen: <Taste druecken>"
		  read
		  deactivate window all
		case lastkey()=27 && Keine Volltextsuche starten
		  exit
	      endcase
	    enddo

	  case lastkey()=83
	  case lastkey()=115
	    clear
	    @0,0 say "BIBLIO: Suchfunktionen: Suchdatenbank loeschen"
	    select 2 && suchdatenbank auswaehlen
	    zap
	    select 1

	  case lastkey()=27
	    exit

	endcase
      enddo
      * vorsichtshalber Arbeitsbereich redefinieren
      select 1
      set filter to

    case lastkey()=78
    case lastkey()=110
      do while .t.

	clear

	store space(254) to e_autoren
	store space(254) to e_titel
	store space(10)  to e_band
	store space(10)  to e_ausgabe
	store space(12)  to e_seiten
	store space(150) to e_journal
	store space(71)  to e_verlag
	store space(51)  to e_ort
	store space(8)   to e_jahr
	store space(20)  to e_sprache
	store space(100) to e_stichworte
	store space(100) to e_sonstiges
	store space(39)  to e_auflage

	@ 0,0 say "BIBLIO: Neue Werke erfassen"
       
	@  3,0  say "Autoren:" get e_autoren 
	@  8,0  say "Titel: " get e_titel
	@ 13,0  say "Journal/In: " get e_journal
	@ 17,0  say "Band: " get e_band picture "XXXXXXXXXX" 
	@ 17,19 say "Ausgabe: " get e_ausgabe picture "XXXXXXXXXX" 
	@ 17,40 say " Seiten: " get e_seiten picture "XXXXXXXXXXXX" 
	@ 17,62 say " Jahr: " get e_jahr picture "XXXXXXXX"
	@ 19,0  say "Auflage: " get e_auflage picture "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
	@ 21,0  say "Verlag: " get e_verlag
	@ 23,0  say "Ort: " get e_ort
	@ 25,0  say "Sprache: " get e_sprache
	@ 27,0  say "Stichworte:" get e_stichworte
	@ 30,0  say "Sonstiges:" get e_sonstiges
	read
      
	@34,0 say "<ESC> Abbrechen"
	@35,0 say "<CR>  Speichern"
      
	read
      
	do case
	  case lastkey()=27
	    exit
	  case lastkey()=13 && Datensatz speichern
	    append blank
	    replace autoren with e_autoren
	    replace titel with e_titel
	    replace journal with e_journal
	    replace band with e_band
	    replace ausgabe with e_ausgabe
	    replace seiten with e_seiten
	    replace jahr with e_jahr
	    replace auflage with e_auflage
	    replace verlag with e_verlag
	    replace ort with e_ort
	    replace sprache with e_sprache
	    replace stichworte with e_stichworte
	    replace sonstiges with e_sonstiges
	endcase
      enddo

    case lastkey()=80  && Pfade, Wartung
    case lastkey()=112
      clear

      @ 0,0  say "BIBLIO: Pfadeinstellungen, Wartung"
      @ 2,0  say "Datenbanksystem: "+version()
      @ 3,0  say "Betriebssystem : "+os()
      @ 3,60 say "Datum: "+dtoc(date())
      @ 5,0  say "----------------------------------------------------------"
      @ 7,0  say "Datenbanklaufwerk: "
      @ 8,0  say "Pfad: "

      @20,0  say "<CR>  Indexdateien neuaufbauen"
      @21,0  say "<ESC> Zurueck"

      do while .t.  
	read
	do case
	  case lastkey()=13
	    clear
	    @ 0,0 say "BIBLIO: Wartung durchfuehren"
	    @ 2,0 say "Die Datenbank wird jetzt gepackt und anschliessend"
	    @ 3,0 say "neu indiziert."
	    pack
	    wait
	    exit
	  case lastkey()=27
	    exit
	endcase
      enddo

    case lastkey()=68  && Datenbank info Statistik
    case lastkey()=100
	
      diss=0
      habi=0
      jour=0
      samm=0
      sati=0
      dipl=0
      mono=0

      clear

      @ 0,0 say "BIBLIO: Datenbankinfos u. Statistik"
      ?
      ?"Datenbanksystem: ",version()
      ?"Betriebssystem : ",os()
      ?
      ?"Datum          : ",date()
      ?"----------------------------------------------------------"
      ?
      ?"Bibliographie  : ",reccount(), " Werke"
      ?
      set console off        
      go top
      do while eof()=.f.
	do case
	  case quellentyp=1
	    diss=diss+1
	  case quellentyp=2
	    habi=habi+1
	  case quellentyp=3
	    mono=mono+1
	  case quellentyp=4
	    jour=jour+1
	  case quellentyp=5
	    sati=sati+1
	  case quellentyp=6
	    samm=samm+1
	  case quellentyp=7
	    dipl=dipl+1
	endcase
	skip 1
      enddo
      set console on
      ? "Monographien   : ",ltrim(str(mono))
      ? "Diplomarbeiten : ",ltrim(str(dipl))
      ? "Dissertationen : ",ltrim(str(diss))
      ? "Habilitationen : ",ltrim(str(habi))
      ? "Journalartikel : ",ltrim(str(jour))
      ? "Sammelwerke    : ",ltrim(str(samm))
      ? "Sammelwerktitel: ",ltrim(str(sati))
      ? "----------------------------------------------------------"
      
      set console off
      select 2

      diss=0
      habi=0
      jour=0
      samm=0
      sati=0
      dipl=0
      mono=0
       
      set console on
      ?
      ? "Suchdatenbank  : ",reccount(), " Werke"
      ?
      set console off        
      go top
      do while eof()=.f.
	do case
	  case quellentyp=1
	    diss=diss+1
	  case quellentyp=2
	    habi=habi+1
	  case quellentyp=3
	    mono=mono+1
	  case quellentyp=4
	    jour=jour+1
	  case quellentyp=5
	    sati=sati+1
	  case quellentyp=6
	    samm=samm+1
	  case quellentyp=7
	    dipl=dipl+1
	endcase
	skip 1
      enddo
      set console on
      ? "Monographien   : ",ltrim(str(mono))
      ? "Diplomarbeiten : ",ltrim(str(dipl))
      ? "Dissertationen : ",ltrim(str(diss))
      ? "Habilitationen : ",ltrim(str(habi))
      ? "Journalartikel : ",ltrim(str(jour))
      ? "Sammelwerke    : ",ltrim(str(samm))
      ? "Sammelwerktitel: ",ltrim(str(sati))
      select 1

      ?"----------------------------------------------------------"
      ?
      ?"<ESC> Abbrechen"
      ?       
      read      


    case lastkey()=73  && Importieren
    case lastkey()=105
      do while .t.
	clear

	@ 0,0 say "BIBLIO: Importieren von Werken in die Bibliographie"
	?
	?"<M>   Medline"
	?"<V>   VLB"
	?"<D>   Dbase IV Format"
	?
	?"<ESC> Zurueck ins Hauptmenu"
	read

	do case
	  case lastkey()=27
	    exit
	  case lastkey()=68 && Dbase IV Format
	  case lastkey()=86 && vlb
	  case lastkey()=77 && Medline
	endcase
      enddo

    case lastkey()=69 
    case lastkey()=101

       && (e) und (E) Exportieren

       do while .t.
	 go top
	 store 1 to zaehler
	 store "Bibliographie" to ueberschrift
	 store "Bibliographie: Rauschdrogen" to headline
	 clear
	 @ 0,0 say "BIBLIO: Exportieren"
	 
	 @ 7,0 say "Filter      :"
	 @ 8,0 say " <CR>  Alle Datensaetze anzeigen"
	 @ 9,0 say " <M>   Monographien"
	 @10,0 say " <D>   Dissertationen"
	 @11,0 say " <A>   Diplomarbeiten"
	 @12,0 say " <J>   Journalartikel"
	 @13,0 say " <S>   Sammelwerke"
	 @14,0 say " <T>   Sammelwerktitel"
	 @15,0 say " <H>   Habilitationen"
	 read

	 do case
	   case lastkey()=13
	     set filter to
	     @ 7,15 say "Alle Datensaetze"
	   case lastkey()=65     
	   case lastkey()=97
	     set filter to quellentyp=7
	     @ 7,15 say "Nur Diplomarbeiten"
	   case lastkey()=68
	   case lastkey()=100
	     set filter to quellentyp=1
	     @ 7,15 say "Nur Dissertationen"
	   case lastkey()=74
	   case lastkey()=106
	     set filter to quellentyp=4
	     @ 7,15 say "Nur Journalartikel"
	   case lastkey()=77
	   case lastkey()=109
	     set filter to quellentyp=3
	     @ 7,15 say "Nur Monographien"
	   case lastkey()=83
	   case lastkey()=115
	     set filter to quellentyp=6
	     @ 7,15 say "Nur Sammelwerke"
	   case lastkey()=72
	   case lastkey()=104
	     set filter to quellentyp=2
	     @ 7,15 say "Nur Habilitationen"
	   case lastkey()=84
	   case lastkey()=116
	     set filter to quellentyp=5
	     @ 7,15 say "Nur Sammelwerktitel"
	 endcase

	 @ 8,0  say "                                    "
	 @ 9,0  say "<H>:  HTML-Format                   " 
	 @ 10,0 say "<T>:  TXT-Format                    "
	 @ 11,0 say "<D> : DIF-Format                    "
	 @ 12,0 say "                                    "
	 @ 13,0 say "                                    "
	 @ 14,0 say "<ESC> Abbruch und Zurueck           "
	 @ 15,0 say "                                    "
	 read                                            
	   
	 do case
	   case lastkey()=27
	     set filter to
	     exit

	   case lastkey()=72 && HTML-Datei erzeugen
	   case lastkey()=104
	     @ 9,0 say "Exportformat: <HTML>"
	     @10,0 say "                                     "
	     @11,0 say "                                     "
	     
	     @11,0 say "Titel               : " get ueberschrift picture "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
	     @12,0 say "Ueberschrift <title>: " get headline     picture "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
	     read
	     
	     
	     
	     set alternate to c:\html\biblio\export.htm
	     
	     
	     set console off
	     set alternate on
	     ?"<html><head><title>"+rtrim(headline)+"</title></head><body>"+"<h1>"+rtrim(ueberschrift)+"</h1>"
	     ?"<ol>"

	     do while eof()=.f.
	       ?"<li>"

	       if len(rtrim(autoren))<>0
		 ?? rtrim(autoren)
		 ?? ": "
	       else
		 ?? "???: "
	       endif

	    
	       if len(rtrim(titel))<>0
		 ?? '"'
		 ?? rtrim(titel)
		 ?? '", '
	       endif
	       
	       if len(rtrim(journal))<>0
		 ?? rtrim(journal)+", "
	       endif
	       
	       if len(rtrim(ausgabe))<>0
		 ?? rtrim(ausgabe)+", "
	       endif
	       
	       if len(rtrim(band))<>0
		 ?? rtrim(band)+", "
	       endif
	       
	       if len(rtrim(seiten))<>0
		 ?? "S. "+rtrim(seiten)+", "
	       endif
	       
	       if len(rtrim(verlag))<>0
		 ?? rtrim(verlag),", "
	       endif
	       
	       if len(rtrim(auflage))<>0
		 ?? rtrim(auflage),", "
	       endif

	       if len(rtrim(ort))<>0
		 ?? rtrim(ort)
		 ?? ", "
	       endif

	       if len(rtrim(jahr))<>0
		 ?? rtrim(jahr)
	       endif

	       ?? "."
	       ??"<br>"
	       
	       set alternate off
	       set console on
	       @ 14,0 say "Es wurden bereits "+ltrim(str(zaehler))+" Werk(e) exportiert..."
	       set console off
	       skip 1
	       zaehler=zaehler+1
	       set alternate on

	     enddo
	     

	     ?"</ol>"
	     ?"</body></html>"
	     set alternate off
	     set console on

	   case lastkey()=68 && DIF-Datei erzeugen
	   case lastkey()=100
	     @ 9,0 say "Exportformat: <DIF>                  "
	     @10,0 say "                                     "
	     @11,0 say "                                     "
	     set alternate to c:\html\biblio\export.dif
	     set alternate on
	     set console off               
	     
	     do while eof()=.f.                
	       ?'"'  
	       ?? autoren
	       ??'","'
	       ?? titel
	       ??'","'
	       ?? journal
	       ??'","'
	       ?? band
	       ??'","'
	       ?? ausgabe
	       ??'","'
	       ?? seiten
	       ??'","'
	       ?? verlag
	       ??'","'
	       ?? ort
	       ??'","'
	       ?? auflage
	       ??'","'
	       ?? jahr
	       ?? '","'
	       ?? quellentyp
	       ??'","'
	       ?? sonstiges
	       ??'","'
	       ?? stichworte
	       ??'","'
	       ?? sprache
	       ??'"'

	       set alternate off
	       set console on
	       @ 14,0 say "Es wurden bereits "+ltrim(str(zaehler))+" Werk(e) exportiert..."
	       set console off
	       skip 1
	       zaehler=zaehler+1
	       set alternate on
	     
	     enddo
	     set alternate off
	     set console on

	   case lastkey()=84 && TXT-Datei erzeugen
	   case lastkey()=116
	     @ 9,0 say "Exportformat: <TXT>"
	     @10,0 say "                                     "
	     @11,0 say "                                     "
	     set alternate to c:\html\biblio\export.txt
	     set alternate on
	     set console off               
	     
	     do while eof()=.f.                
	       
	       ? ltrim(str(zaehler))+". "

	       if len(rtrim(autoren))<>0
		 ?? rtrim(autoren)
		 ?? ": "
	       else
		 ?? "???: "
	       endif

	       if len(rtrim(titel))<>0
		 ?? '"'
		 ?? rtrim(titel)
		 ?? '", '
	       endif

	       if len(rtrim(journal))<>0
		 ?? rtrim(journal)
		 ?? ", "
	       endif

	       if len(rtrim(auflage))<>0
		 ?? rtrim(auflage)
		 ?? ", "
	       endif

	       if len(rtrim(ausgabe))<>0
		 ?? rtrim(ausgabe)
		 ?? ", "
	       endif

	       if len(rtrim(band))<>0
		 ?? rtrim(band)
		 ?? ", "
	       endif

	       if len(rtrim(seiten))<>0
		 ?? "S. "
		 ?? rtrim(seiten)
		 ?? ", "
	       endif

	       if len(rtrim(verlag))<>0
		 ?? rtrim(verlag)
		 ?? ", "
	       endif

	       if len(rtrim(ort))<>0
		 ?? rtrim(ort)
		 ?? ", "
	       endif

	       if len(rtrim(jahr))<>0
		 ?? rtrim(jahr)
	       endif

	       ?? "."
	       
	       set alternate off
	       set console on
	       @ 14,0 say "Es wurden bereits "+ltrim(str(zaehler))+" Werk(e) exportiert..."
	       set console off
	       skip 1
	       zaehler=zaehler+1
	       set alternate on
	     enddo
	     set alternate off
	     set console on
	 endcase
       enddo

    case lastkey()=13 && Werke bearbeiten
      
      do while .t.

	clear
	@ 0,0 say "BIBLIO: Werke bearbeiten"
	?

	? " Filter einstellen:"
	? 
	? " <CR>  Alle Datensaetze anzeigen"
	? 
	? " <M>   Monographien"
	? " <D>   Dissertationen"
	? " <A>   Diplomarbeiten"
	? " <J>   Journalartikel"
	? " <S>   Sammelwerke"
	? " <T>   Sammelwerktitel"
	? " <H>   Habilitationen"
	?
	? "<ESC> Zurueck ins Hauptmenu"

	read

	do case

	  case lastkey()=13 && Alle Datensaetze anzeigen
	    
	    set filter to
	    browse fields autoren /R /30, titel /R /50, jahr /R
	    
	  case lastkey()=27
	    set filter to
	    exit
	  
	  case lastkey()=65     
	    set filter to quellentyp=7
	    browse fields autoren /R /30, titel /R /50
	  
	  case lastkey()=68
	    set filter to quellentyp=1
	    browse fields autoren /R /30, titel /R /50
	  case lastkey()=74
	    set filter to quellentyp=4
	    browse fields autoren /R /30, titel /R /50, journal /R, band /R, ausgabe /R, seiten /R, jahr /R
	  case lastkey()=77
	    set filter to quellentyp=3
	    browse fields autoren /R /30, titel /R /50, verlag /R, ort /R, jahr /R
	  case lastkey()=83
	    set filter to quellentyp=6
	    browse fields autoren /R /30, titel /R /50
	  case lastkey()=72
	    set filter to quellentyp=2
	    browse fields autoren /R /30, titel /R /50
	  case lastkey()=84
	    set filter to quellentyp=5
	    browse fields autoren /R /30, titel /R /50

	endcase

	set filter to
      
      enddo

  endcase

enddo


*
* Proceduren
*
procedure werksuch
			
  set console off

  zaehler=zaehler+1
			  
  set console on
  
  if zaehler=1
    @ 5,1 say "Es wurde "+ltrim(str(zaehler))+" Werk gefunden."
  else
    @ 5,1 say "Es wurden "+ltrim(str(zaehler))+" Werke gefunden."
  endif

  set console off

  au=autoren
  ti=titel
  or=ort
  sp=sprache
  ba=band
  as=ausgabe
  ja=jahr
  so=sonstiges
  st=stichworte
  se=seiten
  ve=verlag
  af=auflage
  jo=journal
  qu=quellentyp

  select 2 && Suchdatenbank auswaehlen

  append blank

  replace autoren    with au
  replace titel      with ti
  replace ort        with or
  replace sprache    with sp
  replace band       with ba
  replace ausgabe    with as
  replace jahr       with ja
  replace sonstiges  with so
  replace stichworte with st
  replace seiten     with se
  replace verlag     with ve
  replace auflage    with af
  replace journal    with jo
  replace quellentyp with qu

  select 1 && Zurueck zur Datenbank Werke

  set console on

return
